;##################################################################
; DIALOGAPP
;##################################################################

#include "MenuTB.Inc"

CONSTANT SECTION
	USER_TBNDROPDOWN	equ		WM_USER+200
DATA SECTION
	hInst				DD 	0
	hDlg				DD	0
	hBkBrush			DD	0
	hTBBkGrnd			DD	0
	hToolBar			DD	0
	hIcon				DD	0
	
	hHook				DD	0

	Mnu0Item0			db "&Menu 0 Item 0",0
	Mnu0Item1			db "Menu 0 Item 1",0
	Mnu0Item2			db "Menu 0 Item 2",0

	Mnu1Item0			db "Menu 1 Item 0",0
	Mnu1Item1			db "Menu 1 Item 1",0
	Mnu1Item2			db "Menu 1 Item 2",0
	Mnu1Item3			db "Menu 1 Item 3",0
	Mnu1Item4			db "Menu 1 Item 4",0
	Mnu1Item5			db "Menu 1 Item 5",0

	Mnu2Item0			db "Menu 2 Item 0",0
	Mnu2Item1			db "Menu 2 Item 1",0
	Mnu2Item2			db "Menu 2 Item 2",0
	Mnu2Item3			db "Menu 2 Item 3",0

	Mnu3Item0			db "Menu 3 Item 0",0
	Mnu3Item1			db "Menu 3 Item 1",0

	TbStrings			db "Menu &0",0
						db "Menu &1",0
						db "Menu &2",0
						db "Menu &3",0,0

	; Start the button IDs at one so we don't use 0 (we'll have to dec in order to get the right menu)
	TbBtns				TBBUTTON			<0,1,TBSTATE_ENABLED,TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN,0,0,0>
						TBBUTTON			<1,2,TBSTATE_ENABLED,TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN,0,0,1>
						TBBUTTON			<3,3,TBSTATE_ENABLED,TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN,0,0,2>
						TBBUTTON			<4,4,TBSTATE_ENABLED,TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN,0,0,3>

	nTbBtns				dd	4
	
	hMenus				dd	0,0,0,0,0,0,0,0
	hBmp				dd	0

	CurrentBtn			dd 0
	nmtb				NMTOOLBAR	<>

CODE SECTION

Start:

	INVOKE GetModuleHandle, 0
	MOV [hInst],EAX
	invoke CreateSolidBrush,0FF00FFh
	mov [hBkBrush],eax
	invoke InitCommonControls
	invoke BuildMenus
	
	INVOKE DialogBoxParam,[hInst],1000,0,ADDR DlgProc,0
	invoke DeleteObject,[hBkBrush]
	invoke DestroyMenu,[hMenus+0]
	invoke DestroyMenu,[hMenus+4]
	invoke DestroyMenu,[hMenus+8]
	invoke DestroyMenu,[hMenus+12]
	invoke DeleteObject,[hBmp]
	INVOKE ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi, esi
	LOCAL rct		:RECT
	LOCAL pt		:POINT
	LOCAL hPopMenu	:D
	LOCAL tbb		:TBBUTTON
	LOCAL pID		:D

	mov eax,[uMsg]

	.WMINITDIALOG
		cmp eax,WM_INITDIALOG
		jne >>.WMCOMMAND
		push	[hwnd]
		pop		[hDlg]
		invoke LoadImage,[hInst],5003,IMAGE_ICON,0,0,LR_DEFAULTCOLOR
		mov [hIcon],eax
		invoke GetDlgItem,[hDlg],1001
		mov [hToolBar],eax
		invoke CreateToolBar
		jmp >>.EXIT

	.WMCOMMAND
		cmp eax,WM_COMMAND
		jne >>.USERTBNDROPDOWN
		jmp >>.EXIT

	.USERTBNDROPDOWN
		cmp eax,USER_TBNDROPDOWN
		jne >>.WMNOTIFY
		jmp >.DODROPDOWN

	.WMNOTIFY
		cmp eax, WM_NOTIFY
		jne >>.WMEXITSIZEMOVE
		mov edx,[lParam]
		mov eax,[edx + NMHDR.code]
		cmp eax, TBN_DROPDOWN
		jne >>.TBNHOTITEMCHANGE
			.DODROPDOWN
			mov edi,[lParam]
			mov eax,[edi+NMTOOLBAR.iItem]
			invoke SendMessage,[hToolBar],TB_COMMANDTOINDEX,eax,0
			mov ecx,eax
			invoke SendMessage,[hToolBar],TB_GETITEMRECT,ecx,ADDR rct
			mov eax,[rct.left]
			mov [pt.x],eax
			mov eax,[rct.bottom]
			mov [pt.y],eax
			invoke ClientToScreen,[hToolBar],ADDR pt
			mov eax,[edi+NMTOOLBAR.iItem]
			dec eax
			shl eax,2
			add eax,OFFSET hMenus
			mov eax,[eax]
			mov [hPopMenu],eax
			mov eax,[hHook]
			test eax,eax
			jz >
				invoke UnhookWindowsHookEx,[hHook]
				mov D[hHook],NULL
			:
			invoke TBMenuHook.dll:InstallHook,[hToolBar]
			mov [hHook],eax
			mov eax,[edi+NMTOOLBAR.iItem]
			
			invoke SendMessage,[hToolBar],TB_PRESSBUTTON,[edi+NMTOOLBAR.iItem],TRUE
			invoke TrackPopupMenu,[hPopMenu],TPM_LEFTALIGN or TPM_RETURNCMD,[pt.x],[pt.y],NULL,[hToolBar],NULL
			cmp eax,0
			jne >
				invoke SendMessage,[hDlg],WM_COMMAND,eax,0
			:
			invoke SendMessage,[hToolBar],TB_PRESSBUTTON,[edi+NMTOOLBAR.iItem],FALSE
			invoke UnhookWindowsHookEx,[hHook]
			mov D[hHook],NULL
			xor eax,eax
			inc eax
			ret

		.TBNHOTITEMCHANGE
			cmp eax,TBN_HOTITEMCHANGE
			jne >>.TBNQUERYINSERT
				mov edi,[lParam]
				cmp D[edi+NMHDR.idFrom],1001
				jne >>.DEFPROC
				invoke SendMessage,[hToolBar],TB_GETSTATE,[edi+NMTBHOTITEM.idNew],0
				test eax,TBSTATE_ENABLED
				jz >Z2
				cmp D[hHook],0
				jne >Z2
				Z1:
					xor eax,eax
					inc eax
					ret
				Z2:
				mov eax,[edi+NMTBHOTITEM.idNew]
				push eax
				or eax,eax
				jz <Z1
				cmp eax,[CurrentBtn]
				jz <Z1
				invoke SendMessage,[hToolBar],TB_PRESSBUTTON,[CurrentBtn],FALSE
				pop eax
				mov eax,[edi+NMTBHOTITEM.idNew]
				mov [CurrentBtn],eax
				mov [nmtb.iItem],eax
				mov eax,[hToolBar]
				mov [nmtb.hdr.hwndFrom],eax
				mov D[nmtb.hdr.code],TBN_DROPDOWN
				mov D[nmtb.hdr.idFrom],1001
				invoke SendMessage,[hToolBar],WM_CANCELMODE,0,0
				invoke PostMessage,[hwnd],USER_TBNDROPDOWN,0,OFFSET nmtb
				xor eax,eax
				inc eax
				ret

		.TBNQUERYINSERT
			cmp eax, TBN_QUERYINSERT
			jne >>.TBNQUERYDELETE
				invoke SetWindowLong,[hwnd],DWL_MSGRESULT,TRUE
				xor eax,eax
				inc eax
				ret

		.TBNQUERYDELETE
			cmp eax, TBN_QUERYDELETE
			jne >>.TBNGETBUTTONINFO
				invoke SetWindowLong,[hwnd],DWL_MSGRESULT,TRUE
				xor eax,eax
				inc eax
				ret

		.TBNGETBUTTONINFO
			cmp eax, TBN_GETBUTTONINFO
			jne >>.TBNINITCUSTOMIZE
				mov edi,[lParam]
				mov eax,[edi+NMTOOLBAR.hdr.hwndFrom]
				cmp eax,[hToolBar]
				jne >>.DEFPROC
					mov esi,[edi+NMTOOLBAR.iItem]
					add edi,NMTOOLBAR.tbButton
					cmp esi, [nTbBtns]
					jge >
						mov eax,SIZEOF TBBUTTON
						mul esi
						add eax,OFFSET TbBtns
						push SIZEOF TBBUTTON
						push edi
						push eax
						call memcopy
						invoke SetWindowLong,[hwnd],DWL_MSGRESULT,TRUE
						xor eax,eax
						inc eax
						ret
					:
						invoke SetWindowLong,[hwnd],DWL_MSGRESULT,FALSE
						xor eax,eax
						inc eax
						ret

		.TBNINITCUSTOMIZE
			cmp eax, TBN_INITCUSTOMIZE
			jne >>.DEFPROC
				invoke SetWindowLong,[hwnd],DWL_MSGRESULT,TBNRF_HIDEHELP
				xor eax,eax
				inc eax
				ret

	.WMEXITSIZEMOVE
		cmp eax,WM_EXITSIZEMOVE
		jne >.WMSIZE
			invoke InvalidateRect,[hToolBar],NULL,TRUE
			invoke UpdateWindow,[hToolBar]
			ret

	.WMSIZE
		cmp eax,WM_SIZE
		jne >>.WMCLOSE
		invoke SendMessage,[hToolBar],TB_AUTOSIZE,0,0
		invoke InvalidateRect,[hToolBar],NULL,TRUE
		jmp >>.DEFPROC

	.WMCLOSE
		cmp eax,WM_CLOSE
		JNE >>.DEFPROC
		invoke EndDialog,[hwnd],0

	.DEFPROC
		xor eax,eax
		RET

	.EXIT

	xor eax,eax
	inc eax
	RET
ENDF

BuildMenus FRAME
	uses edi
	LOCAL mi		:MENUINFO

	invoke LoadImage,[hInst],5001,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION
	mov [hBmp],eax
	invoke CreatePatternBrush,eax
	mov [hTBBkGrnd],eax
	mov [mi.hbrBack],eax
	mov D[mi.cbSize],SIZEOF MENUINFO
	mov D[mi.fMask],MIM_BACKGROUND

	mov edi,OFFSET hMenus

	invoke CreatePopupMenu
	mov [edi+0],eax
	invoke AppendMenu,[edi+0],MF_STRING,6001,OFFSET Mnu0Item0
	invoke AppendMenu,[edi+0],MF_STRING,6002,OFFSET Mnu0Item1
	invoke AppendMenu,[edi+0],MF_STRING,6003,OFFSET Mnu0Item2
	invoke SetMenuInfo,[edi+0],ADDR mi

	invoke CreatePopupMenu
	mov [edi+4],eax
	invoke AppendMenu,[edi+4],MF_STRING,6101,OFFSET Mnu1Item0
	invoke AppendMenu,[edi+4],MF_STRING,6102,OFFSET Mnu1Item1
	invoke AppendMenu,[edi+4],MF_STRING,6103,OFFSET Mnu1Item2
	invoke AppendMenu,[edi+4],MF_STRING,6104,OFFSET Mnu1Item3
	invoke AppendMenu,[edi+4],MF_STRING,6105,OFFSET Mnu1Item4
	invoke AppendMenu,[edi+4],MF_STRING,6106,OFFSET Mnu1Item5
	invoke SetMenuInfo,[edi+4],ADDR mi
	
	invoke CreatePopupMenu
	mov [edi+8],eax
	invoke AppendMenu,[edi+8],MF_STRING,6201,OFFSET Mnu2Item0
	invoke AppendMenu,[edi+8],MF_STRING,6202,OFFSET Mnu2Item1
	invoke AppendMenu,[edi+8],MF_STRING,6203,OFFSET Mnu2Item2
	invoke AppendMenu,[edi+8],MF_STRING,6204,OFFSET Mnu2Item3
	invoke SetMenuInfo,[edi+8],ADDR mi
	
	invoke CreatePopupMenu
	mov [edi+12],eax
	invoke AppendMenu,[edi+12],MF_STRING,6301,OFFSET Mnu3Item0
	invoke AppendMenu,[edi+12],MF_STRING,6302,OFFSET Mnu3Item1
	invoke SetMenuInfo,[edi+12],ADDR mi

	ret
endf

SubClassTB FRAME hWin,uMsg,wParam,lParam
	LOCAL hdc		:D
	LOCAL memDC		:D
	LOCAL memBmp	:D
	LOCAL defObj	:D
	LOCAL rect		:RECT
	LOCAL tbb		:TBBUTTON

	cmp D[uMsg], WM_ERASEBKGND
	jne >>.Exit
		mov eax,[wParam]
		mov [hdc],eax
		
		; Create a backbuffer
		invoke CreateCompatibleDC,eax
		mov [memDC],eax
		invoke GetClientRect,[hWin],ADDR rect
		invoke CreateCompatibleBitmap,[hdc],[rect.right],[rect.bottom]
		mov [memBmp],eax
		invoke SelectObject,[memDC],[memBmp]
		mov [defObj],eax
		
		invoke FillRect,[memDC],ADDR rect,[hTBBkGrnd]

		; Center vertically
		mov ecx,[rect.bottom]
		sub ecx,16
		shr ecx,1

		; Position the icon
		mov eax,[rect.right]
		sub eax,ecx
		sub eax,16

		invoke DrawIconEx,[memDC],eax,ecx,[hIcon],16,16,FALSE,FALSE,DI_NORMAL

		mov eax,[rect.bottom]
		sub eax,2
		mov [rect.top],eax
		mov D[rect.bottom],2
		invoke DrawEdge,[memDC],offset rect,EDGE_ETCHED,BF_TOP
		
		invoke GetClientRect,[hWin],ADDR rect
		; Copy the backbuffer to the Toolbar
		invoke BitBlt,[hdc],0,0,[rect.right],[rect.bottom],[memDC],0,0,SRCCOPY
		
		; Destroy the backbuffer
		invoke SelectObject,[memDC],[defObj]
		invoke DeleteObject,[memBmp]
		invoke DeleteDC,[memDC]

		mov eax,1
		ret
	.Exit

	invoke GetWindowLong,[hWin],GWL_USERDATA
	invoke CallWindowProc,eax,[hWin],[uMsg],[wParam],[lParam]
	ret

endf

CreateToolBar:

	invoke GetWindowLong,[hToolBar],GWL_WNDPROC
	invoke SetWindowLong,[hToolBar],GWL_USERDATA,eax
	invoke SetWindowLong,[hToolBar],GWL_WNDPROC,OFFSET SubClassTB

	invoke GetWindowLong,[hToolBar],GWL_STYLE
	or eax,040h + CCS_ADJUSTABLE
	invoke SetWindowLong,[hToolBar],GWL_STYLE,eax

	invoke ImageList_LoadImage,[hInst],5000,16,10,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke SendMessage,[hToolBar],TB_SETIMAGELIST,0,eax

	invoke ImageList_LoadImage,[hInst],5002,16,10,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke SendMessage,[hToolBar],TB_SETDISABLEDIMAGELIST,0,eax

	invoke SendMessage,[hToolBar],TB_BUTTONSTRUCTSIZE,SIZEOF TBBUTTON,0

	invoke SendMessage,[hToolBar],TB_ADDSTRING,NULL,OFFSET TbStrings
	invoke SendMessage,[hToolBar],TB_ADDBUTTONS,[nTbBtns],OFFSET TbBtns

	invoke SendMessage,[hToolBar],TB_AUTOSIZE,0,0

	ret

memcopy FRAME lpSource,lpDest,nBytes
	uses edi,esi,ecx
	cld
	mov edi,[lpDest]
	mov esi,[lpSource]
	mov ecx,[nBytes]
	
	; do the evenly divisible ones
	shr ecx,2
	rep movsd
	
	; do the remainder
	mov ecx,[nBytes]
	and ecx,3
	rep movsb
	
	RET
ENDF

AddToTopScores FRAME score,pSysTime
	
	
	
	RET
ENDF
